/* -*- buffer-read-only: t -*- vi: set ro:
#line 382
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
#line 382
*/
#ifdef HAVE_CONFIG_H
# include <config.h>
#endif
#include <sys/types.h>
#include "mailfrom.h"
#include "prog.h"
#include "builtin.h"

#line 17 "bi_dns.m4"
/* This file is part of mailfrom filter.             -*- c -*-
#line 17
   Copyright (C) 2006 Sergey Poznyakoff
#line 17

#line 17
   This program is free software; you can redistribute it and/or modify
#line 17
   it under the terms of the GNU General Public License as published by
#line 17
   the Free Software Foundation; either version 2, or (at your option)
#line 17
   any later version.
#line 17

#line 17
   This program is distributed in the hope that it will be useful,
#line 17
   but WITHOUT ANY WARRANTY; without even the implied warranty of
#line 17
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#line 17
   GNU General Public License for more details.
#line 17

#line 17
   You should have received a copy of the GNU General Public License
#line 17
   along with this program; if not, write to the Free Software
#line 17
   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#line 17
   MA 02110-1301 USA */

#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <arpa/inet.h>

void
#line 24
bi_hostname(eval_environ_t env)
#line 24 "bi_dns.m4"
{
#line 24
	
#line 24
char * string = (char *) get_arg(env, 0);
#line 24
        
#line 24
        adjust_stack(env, 1);
#line 24

#line 24
	if (prog_trace_option & BUILTIN_MASK_dns)
#line 24
		prog_trace(env, "hostname %s",string);;
#line 24

{
	char *hbuf;
	if (resolve_ipstr(string, &hbuf) != mf_success) 
		pushs(env, string);
	else {
		pushs(env, hbuf);
		free(hbuf);
	}
}
}

void
#line 36
bi_resolve(eval_environ_t env)
#line 36 "bi_dns.m4"
{
#line 36
	
#line 36
char * string = (char *) get_arg(env, 0);
#line 36
        
#line 36
        adjust_stack(env, 1);
#line 36

#line 36
	if (prog_trace_option & BUILTIN_MASK_dns)
#line 36
		prog_trace(env, "resolve %s",string);;
#line 36

{
	char *ipstr;
	if (resolve_hostname(string, &ipstr) != mf_success)
		pushs(env, "0");
	else {
		pushs(env, ipstr);
		free(ipstr);
	}
}
}

void
#line 48
bi_hasmx(eval_environ_t env)
#line 48 "bi_dns.m4"
{
#line 48
	
#line 48
char * string = (char *) get_arg(env, 0);
#line 48
        
#line 48
        adjust_stack(env, 1);
#line 48

#line 48
	if (prog_trace_option & BUILTIN_MASK_dns)
#line 48
		prog_trace(env, "hasmx %s",string);;
#line 48

{
	mxbuf_t mxbuf;
	mf_status mxstat;

	mxstat = getmx(string, mxbuf);
	
	if (mxstat != mf_success) {
		if (env_catch(env, mxstat) == 0)
			return;
	} else
		freemx(mxbuf);

	do {
#line 61
push(env, (STKVAL) (mxstat == mf_success));
#line 61
return;
#line 61
} while (0);
}
}

static int
resolve_host(const char *string, unsigned long *ip)
{
	int rc;
	struct in_addr addr;
	char *ipstr;

	if (inet_aton(string, &addr)) {
		*ip = addr.s_addr;
		return 0;
	}
	
	if (resolve_hostname(string, &ipstr) != mf_success)
		return 1;

	rc = inet_aton(ipstr, &addr);
	free(ipstr);
	if (rc == 0) {
		mu_error("INTERNAL ERROR at %s:%lu: resolve_hostname returned "
			 "invalid IP address: %s",
			 __FILE__, __FILE__, ipstr);
		return 1;
	}
	*ip = addr.s_addr;
	return 0;
}

void
#line 92
bi_ismx(eval_environ_t env)
#line 92 "bi_dns.m4"
{
#line 92
	
#line 92
char * domain = (char *) get_arg(env, 1);
#line 92
        char * ipstr = (char *) get_arg(env, 0);
#line 92
        
#line 92
        adjust_stack(env, 2);
#line 92

#line 92
	if (prog_trace_option & BUILTIN_MASK_dns)
#line 92
		prog_trace(env, "ismx %s %s",domain, ipstr);;
#line 92

{
	mxbuf_t mxbuf;
	mf_status mxstat;
	unsigned long ip;
	int rc = 0;
	
		if (!(resolve_host(ipstr, &ip) == 0))
			do {
#line 100
		if (env_catch(env, mf_resolve) == 0)
#line 100
			return ;
#line 100
		else
#line 100
			runtime_error(env,
#line 100
				                                                  "ismx: " "cannot resolve host name %s",ipstr);
#line 100
	} while (0) 
#line 100
;
#line 100
;
	
	mxstat = getmx(domain, mxbuf);
	
	if (mxstat != mf_success) {
		if (env_catch(env, mxstat) == 0)
			return;
	} else {
		int i;

		for (i = 0; i < MAXMXCOUNT && mxbuf[i]; i++) {
			unsigned long n;
			
			if (!resolve_host(mxbuf[i], &n) && n == ip) {
				rc = 1;
				break;
			}
		}
		freemx(mxbuf);
	}
	do {
#line 120
push(env, (STKVAL) (rc));
#line 120
return;
#line 120
} while (0);
}
}

void
#line 124
bi_relayed(eval_environ_t env)
#line 124 "bi_dns.m4"
{
#line 124
	
#line 124
char * s = (char *) get_arg(env, 0);
#line 124
        
#line 124
        adjust_stack(env, 1);
#line 124

#line 124
	if (prog_trace_option & BUILTIN_MASK_dns)
#line 124
		prog_trace(env, "relayed %s",s);;
#line 124

{
	do {
#line 126
push(env, (STKVAL) (relayed_domain_p(s)));
#line 126
return;
#line 126
} while (0);
}
}

void
#line 130
bi_listens(eval_environ_t env)
#line 130 "bi_dns.m4"
{
#line 130
	
#line 130
char * s = (char *) get_arg(env, 0);
#line 130
        
#line 130
        adjust_stack(env, 1);
#line 130

#line 130
	if (prog_trace_option & BUILTIN_MASK_dns)
#line 130
		prog_trace(env, "listens %s",s);;
#line 130

{
	do {
#line 132
push(env, (STKVAL) (listens_on (s, 25) == mf_success));
#line 132
return;
#line 132
} while (0);
}
}

void
#line 136
bi_match_cidr(eval_environ_t env)
#line 136 "bi_dns.m4"
{
#line 136
	
#line 136
char * ipstr = (char *) get_arg(env, 1);
#line 136
        char * cidrstr = (char *) get_arg(env, 0);
#line 136
        
#line 136
        adjust_stack(env, 2);
#line 136

#line 136
	if (prog_trace_option & BUILTIN_MASK_dns)
#line 136
		prog_trace(env, "match_cidr %s %s",ipstr, cidrstr);;
#line 136

{
	char *p;
	struct in_addr addr, cidr;
	char netbuf[16], *netstr;
	unsigned long netmask;
	int result = 0;
	const struct locus *locus = env_get_locus(env);
	
	do {
			if (!(inet_aton(ipstr, &addr)))
#line 149
			do {
#line 149
		if (env_catch(env, mf_invip) == 0)
#line 149
			return ;
#line 149
		else
#line 149
			runtime_error(env,
#line 149
				                                                  "match_cidr: " "invalid IP address (%s)",ipstr);
#line 149
	} while (0) 
#line 149
;
#line 149
;
		p = strchr(cidrstr, '/');
		if (!p) {
			netstr = cidrstr;
			netmask = 0xfffffffful;
		} else {
			size_t len = p - cidrstr;
			unsigned long n;
			
				if (!(len < sizeof netbuf))
#line 160
			do {
#line 160
		if (env_catch(env, mf_invcidr) == 0)
#line 160
			return ;
#line 160
		else
#line 160
			runtime_error(env,
#line 160
				                                                  "match_cidr: " "invalid CIDR (%s)",cidrstr);
#line 160
	} while (0) 
#line 160
;
#line 160
;
			memcpy(netbuf, cidrstr, len);
			netbuf[len] = 0;
			netstr = netbuf;
			n = strtoul(p + 1, &p, 10);
				if (!(*p == 0 && n <= 32))
			do {
#line 166
		if (env_catch(env, mf_invcidr) == 0)
#line 166
			return ;
#line 166
		else
#line 166
			runtime_error(env,
#line 166
				                                                  "match_cidr: " "invalid CIDR (netmask of %s)",cidrstr);
#line 166
	} while (0) 
#line 166
;
#line 166
;
			n = 32 - n;
			if (n == 32)
				netmask = 0;
			else
				netmask = (0xfffffffful >> n) << n;
		}
			if (!(inet_aton(netstr, &cidr)))
#line 175
			do {
#line 175
		if (env_catch(env, mf_invcidr) == 0)
#line 175
			return ;
#line 175
		else
#line 175
			runtime_error(env,
#line 175
				                                                  "match_cidr: " "invalid CIDR (network part of %s)",cidrstr);
#line 175
	} while (0) 
#line 175
;
#line 175
;

		addr.s_addr = ntohl(addr.s_addr);
		cidr.s_addr = ntohl(cidr.s_addr);
		debug5(100, "%s:%lu: addr=%lx net=%lx mask=%lx" ,
		       locus->file, locus->line,
		       addr.s_addr, cidr.s_addr, netmask);
		result = (addr.s_addr & netmask) == cidr.s_addr;
	} while (0);
	do {
#line 184
push(env, (STKVAL) (result));
#line 184
return;
#line 184
} while (0);
}
}

void
#line 188
bi_domainpart(eval_environ_t env)
#line 188 "bi_dns.m4"
{
#line 188
	
#line 188
char * str = (char *) get_arg(env, 0);
#line 188
        
#line 188
        adjust_stack(env, 1);
#line 188

#line 188
	if (prog_trace_option & BUILTIN_MASK_dns)
#line 188
		prog_trace(env, "domainpart %s",str);;
#line 188

{
	char *p = strchr(str, '@');
	do {
#line 191
push(env, (STKVAL) (p ? p+1 : str));
#line 191
return;
#line 191
} while (0);
}
}

void
#line 195
bi_localpart(eval_environ_t env)
#line 195 "bi_dns.m4"
{
#line 195
	
#line 195
char * str = (char *) get_arg(env, 0);
#line 195
        
#line 195
        adjust_stack(env, 1);
#line 195

#line 195
	if (prog_trace_option & BUILTIN_MASK_dns)
#line 195
		prog_trace(env, "localpart %s",str);;
#line 195

{
	char *p = strchr(str, '@');

	if (p) {
		size_t size = p - str;
		char *string_space = heap_reserve(env, size + 1);
		memcpy(string_space, str, size);
		string_space[size] = 0;
		do {
#line 204
push(env, (STKVAL) (string_space));
#line 204
return;
#line 204
} while (0);
	} else
		do {pushs(env, str);
#line 206
return;
#line 206
} while (0);
}
}


#line 210
void
#line 210
dns_init_builtin()
#line 210
{
#line 210
	#line 24 "bi_dns.m4"
va_builtin_install_ex("hostname", bi_hostname, 0, 0, dtype_string,  1, 0,  dtype_string);
#line 36 "bi_dns.m4"
va_builtin_install_ex("resolve", bi_resolve, 0, 0, dtype_string,  1, 0,  dtype_string);
#line 48 "bi_dns.m4"
va_builtin_install_ex("hasmx", bi_hasmx, 0, 0, dtype_number,  1, 0,  dtype_string);
#line 92 "bi_dns.m4"
va_builtin_install_ex("ismx", bi_ismx, 0, 0, dtype_number,  2, 0,  dtype_string, dtype_string);
#line 124 "bi_dns.m4"
va_builtin_install_ex("relayed", bi_relayed, 0, 0, dtype_number,  1, 0,  dtype_string);
#line 130 "bi_dns.m4"
va_builtin_install_ex("listens", bi_listens, 0, 0, dtype_number,  1, 0,  dtype_string);
#line 136 "bi_dns.m4"
va_builtin_install_ex("match_cidr", bi_match_cidr, 0, 0, dtype_number,  2, 0,  dtype_string, dtype_string);
#line 188 "bi_dns.m4"
va_builtin_install_ex("domainpart", bi_domainpart, 0, 0, dtype_string,  1, 0,  dtype_string);
#line 195 "bi_dns.m4"
va_builtin_install_ex("localpart", bi_localpart, 0, 0, dtype_string,  1, 0,  dtype_string);

#line 210 "bi_dns.m4"
		
#line 210
}
#line 0

#line 0

